Boomkinator = LibStub("AceAddon-3.0"):NewAddon("Boomkinator", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local L    = LibStub("AceLocale-3.0"):GetLocale("Boomkinator")

local settings
local UnitBuff = _G.UnitBuff
local UnitDebuff = _G.UnitDebuff
local GetSpellInfo = _G.GetSpellInfo
local GetSpellCooldown= _G.GetSpellCooldown
local sformat = string.format

local updater = ""

-- buttons
local buttons = {}
local timers = {}
local stacks = {}
local ccount

--local bframe, bisIcon, bisTime, bmfIcon, bmfTime, bwrtIcon, bstfIcon, bstsIcon, bstsTime, bfonIcon, bfonTime, bsflIcon, bsflTime
--local bshIcon, brpIcon, brpTime, brpCount, bmnIcon, bmnTime, bsrIcon, bsrTime, brkIcon, brkTime, btfIcon, btfTime, bbsIcon, bbsTime

local mfName, mfIcon, sfName, sfIcon
local bLastCycle = 0

Boomkinator.Credits1 = "Boomkinator - by Aznamir (Lightbringer US)";

-------------------------------------------------------------------
-- Spell Settings
-------------------------------------------------------------------
Boomkinator.OwlSpells = {
	[1] = GetSpellInfo(8921),   -- Moonfire
	[2] = GetSpellInfo(93402),  -- Sunfire
	[3] = GetSpellInfo(5176),   -- Wrath
	[4] = GetSpellInfo(2912),   -- Starfire
	[5] = GetSpellInfo(78674),  -- Starsurge
	[6] = GetSpellInfo(33831),  -- Treants
	[7] = GetSpellInfo(50288),  -- Starfall
	[8] = GetSpellInfo(112071), -- Celestial Alignment
	[9] = GetSpellInfo(78777),  -- wild mushroom: denotate
	[10]= GetSpellInfo(20484),  -- rebirth
	-- self buffs
	[11]= GetSpellInfo(48518), --eclipse lunar
	[12]= GetSpellInfo(48517), --eclipse solar
	[13]= GetSpellInfo(93400), -- shooting stars
}

Boomkinator.CatSpells = {
	[1] = GetSpellInfo(5221), -- shred
	[2] = GetSpellInfo(1079), -- rip
	[3] = GetSpellInfo(33876), -- mangle
	[4] = GetSpellInfo(1822), -- rake	
	[5] = GetSpellInfo(52610), -- savage roar
	[6] = GetSpellInfo(50334), -- berserk
	[7] = GetSpellInfo(5217), -- tiger's fury
	--[8] = GetSpellInfo(46857) -- trauma (warrior)
}

Boomkinator.HunterSpells = {
	--[1] = GetSpellInfo(53209), -- Chimera Shot
	[1] = GetSpellInfo(53301), -- Explosive Shot
	[2] = GetSpellInfo(3674), -- Black Arrow
	[3] = GetSpellInfo(1978), -- Serpent Sting
	[4] = GetSpellInfo(53351), -- Kill Shot
}

Boomkinator.WindwalkerSpells = {
	[1] = GetSpellInfo(125359), -- tiger power
	[2] = GetSpellInfo(118864), -- combo breaker: tiger palm
	[3] = GetSpellInfo(116768), -- combo breaker: blackout kick
	[4] = GetSpellInfo(125195), -- tigereyebrew
	[5] = GetSpellInfo(117418), -- fists of fury
	[6] = GetSpellInfo(107428), -- rising sun kick
}

Boomkinator.CombatSpells = {
	-- debuffs
	[1] = GetSpellInfo(1943), 		-- #6 rupture
	[2] = GetSpellInfo(84617), 		-- #2 reveal strike
	[3] = GetSpellInfo(113746), 	-- #4 weakened armor
	-- buffs
	[4] = GetSpellInfo(5171), 		-- #5 slice and dice
	-- cooldowns
	--[4] = GetSpellInfo(1766), 		-- #2 kick
	--[5] = GetSpellInfo(5938),		-- #3 shiv
	[6]= GetSpellInfo(51690),		-- #7 killing spree
	[7] = GetSpellInfo(13750),		-- #8 adrenaline rush
	[8] = GetSpellInfo(121471), 		-- #9 shadow blades
	-- insights
	[10] = GetSpellInfo(84745), 	-- shallow
	[11] = GetSpellInfo(84746),		-- moderate
	[12] = GetSpellInfo(84747),		-- deep
}

Boomkinator.DemoSpells = {
	[1] = GetSpellInfo(122355), 	-- molten core
	[2] = GetSpellInfo(103958), 	-- metamorphosis
	[3] = GetSpellInfo(172), 		-- corruption
	[4] = GetSpellInfo(603), 		-- doom
	[5] = GetSpellInfo(104316),		-- imp swarm
	[6] = GetSpellInfo(111898),		-- grim felguard
	[7] = GetSpellInfo(77801), 		-- dark soul
	[8] = GetSpellInfo(18540), 		-- doomguard
}

Boomkinator.Icons = {
	["Owl"] = {
		[1] = "Interface\\Icons\\Spell_Nature_StarFall", -- moonfire (button 1)
		[2] = "Interface\\Icons\\Ability_Mage_FireStarter", -- sunfire (button 2)
		[3] = "Interface\\Icons\\Ability_Druid_Starfall", -- starfall (button 6)		
		[4] = "Interface\\Icons\\spell_nature_wrathv2", -- wrath (button 1)
		[5] = "Interface\\Icons\\Spell_Arcane_Arcane03", -- starsurge (button 4)
		[6] = "Interface\\Icons\\Spell_Arcane_StarFire", -- starfire (button 3)
		[7] = "Interface\\Icons\\Ability_Druid_ForceofNature", -- treants (button 5)
		[8] = "Interface\\Icons\\Spell_Nature_NatureGuardian", -- celestial alignment (button 7)
		[9] = "Interface\\Icons\\INV_Mushroom_07", -- mushroom detonate
	},
	["Cat"] = {
		[1] = "Interface\\Icons\\Spell_Shadow_VampiricAura",
		[2] = "Interface\\Icons\\Ability_GhoulFrenzy",
		[3] = "Interface\\Icons\\Ability_Druid_Mangle2",
		[4] = "Interface\\Icons\\Ability_Druid_SkinTeeth",
		[5] = "Interface\\Icons\\Ability_Druid_Disembowel",
		[6] = "Interface\\Icons\\Ability_Mount_JungleTiger",
		[7] = "Interface\\Icons\\Ability_Druid_Berserk",
		[8] = "",
		[9] = "",
--		[10] = "",
	},
	["Hunter"] = {
		--[1] = "Interface\\Icons\\Ability_Hunter_ChimeraShot2",
		[1] = "Interface\\Icons\\Ability_Hunter_ExplosiveShot",
		[2] = "Interface\\Icons\\Spell_Shadow_PainSpike",
		[3] = "",
		[4] = "Interface\\Icons\\Ability_Hunter_Quickshot",
		[5] = "Interface\\Icons\\Ability_Hunter_Assassinate2",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
--		[10] = "",		
	},
	["Windwalker"] = {
		[1] = "Interface\\Icons\\ability_monk_jab", -- jab with chi count
		[2] = "Interface\\Icons\\ability_monk_tigerpalm", -- tiger palm with tiger power stacks 				
		[3] = "Interface\\Icons\\ability_monk_roundhousekick", -- blackout kick
		[4] = "Interface\\Icons\\spell_brew_dark", -- blackout kick,
		[5] = "Interface\\Icons\\monk_ability_fistoffury", -- fists of fury
		[6] = "Interface\\Icons\\ability_monk_risingsunkick", -- rising sun kick
		[7] = "",
		[8] = "",
		[9] = "",
	},
	["Brewmaster"] = {
		[1] = "",
		[2] = "",
		[3] = "",
		[4] = "",
		[5] = "",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
	},
	["Combat"] = {
		-- row 1
		[1] = "Interface\\Icons\\Spell_Shadow_RitualOfSacrifice", 	-- sinister strike + combo count
		[2] = "Interface\\Icons\\INV_sword_97", 					-- revealing strike
		--[2] = "Interface\\Icons\\Ability_Kick", 					-- kick
		[3] = "Interface\\Icons\\INV_Bijou_Silver", 				-- Insight
		-- row 2
		[4] = "Interface\\Icons\\Ability_Warrior_Riposte",			-- expose armor
		[5] = "Interface\\Icons\\Ability_Rogue_SliceDice",			-- s&d
		[6] = "Interface\\Icons\\Ability_Rogue_Rupture",			-- rupture
		-- row 3
		[7] = "Interface\\Icons\\Ability_Rogue_MurderSpree",		-- killing spree
		[8] = "Interface\\Icons\\Spell_Shadow_ShadowWordDominate",	-- adrenaline rush
		[9] = "Interface\\Icons\\inv_knife_1h_grimbatolraid_d_03",	-- shadow blades
		
		--[10] = "Interface\\Icons\\INV_Bijou_Green",
		--[11] = "Interface\\Icons\\INV_Bijou_Yellow",
		--[12] = "Interface\\Icons\\INV_Bijou_Red",
	},
	["Demonology"] = {
		[1] ="Interface\\Icons\\Spell_Shadow_DemonForm", 			-- meta
		[2] ="Interface\\Icons\\Spell_Fire_Fireball02", 			-- soul fire
		[3] ="Interface\\Icons\\ability_warlock_handofguldan", 		-- hand of guildan
		[4] ="Interface\\Icons\\Spell_Shadow_AbominationExplosion", -- corruption
		[5] = "Interface\\Icons\\Spell_Shadow_AuraOfDarkness",		-- doom
		[6] = "INTERFACE\\ICONS\\ability_warlock_impoweredimp",		-- imp swarm
		[7] = "Interface\\Icons\\Spell_Shadow_SummonFelGuard",		-- grim: felguard
		[8] = "INTERFACE\\ICONS\\spell_warlock_demonsoul",
		[9] = "Interface\\Icons\\warlock_summon_doomguard",
		[11] = "INTERFACE\\ICONS\\inv_jewelcrafting_shadowspirit_02",	-- touch of chaos
		[12] = "Interface\\Icons\\Spell_Fire_Fireball02",				-- soul fire
		[13] = "Interface\\Icons\\ability_warlock_coil2",				-- chaos wave
	},
	["None"] = {
		[1] = "",
		[2] = "",
		[3] = "",
		[4] = "",
		[5] = "",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
--		[10] = "",		
	},
}
-------------------------------------------------------------------
-- Interface settings
-------------------------------------------------------------------
Boomkinator.options =
{
	type = "group",
	name = "Boomkinator",
	args = {
		desc = {
			type = "description",
			order = 0,
			name = L["MOVE_DESC"],
		},
		reset = {
			type = "execute",
			order = 1,
			name = L["RESET"],
			desc = L["RESET_DESC"],
			func = function() Boomkinator:Reset() end,
		},
		show = {
			type = "execute",
			order = 2,
			name = L["SHOW"],
			desc = L["SHOW_DESC"],
			func = function() Boomkinator:ShowLayout() end,
		},
		hide = {
			type = "execute",
			order = 3,
			name = L["HIDE"],
			desc = L["HIDE_DESC"],
			func = function() Boomkinator:HideLayout() end,
		},
		lock = {
			type = "execute",
			order = 4,
			name = L["LOCK"],
			desc = L["LOCK_DESC"],
			func = function() 
					settings.locked = true
					Boomkinator:LockLayout() 
				end,
		},
		unlock = {
			type = "execute",
			order = 5,
			name = L["UNLOCK"],
			desc = L["UNLOCK_DESC"],
			func = function()
					settings.locked = false
					Boomkinator:UnlockLayout()
				end,
		},
		scale = {
			type = "range",
			order = 6,
			name = L["BSC"],
			desc = L["BSC_DESC"],
			min = 0.4,
			max = 1.5,
			step = 0.05,
			get = function(info) return settings.buffscale end,
			set = function(info, val)
					settings.buffscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		fontscale = {
			type = "range",
			order = 7,
			name = "Font Scale",
			desc = "Scale of timer fonts", 
			min = 8,
			max = 14,
			step = 1,
			get = function(info) return settings.fontscale end,
			set = function(info, val)
					settings.fontscale = val
					Boomkinator:UpdateLayout()
				end,
		}
	},
}
-------------------------------------------------------------------
-- Default Settings
-------------------------------------------------------------------
Boomkinator.defaults = {
	profile = {
		buffscale = 0.9,
		fontscale = 10,
		locked = false,
		disabled = false,
	}
}
-------------------------------------------------------------------
-- Ace Framework Events
-------------------------------------------------------------------
function Boomkinator:OnInitialize()
	--self:Print("OnInitialize")
	DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99"..Boomkinator.Credits1.."|r")
	self.db = LibStub("AceDB-3.0"):New("BoomkinatorDB", Boomkinator.defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	settings = self.db.profile
	Boomkinator.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Boomkinator", Boomkinator.options, "boom")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Boomkinator", "Boomkinator")

	self:UpdateLayout()
end

function Boomkinator:OnProfileChanged()
	--self:Print("OnProfileChanged")
	settings = self.db.profile
	self:UpdateLayout()
end

function Boomkinator:OnEnable()
	--self:Print("OnEnable")
	settings.disabled = false
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:UpdateLayout()
end

function Boomkinator:OnDisable()
	--self:Print("OnDisable")
	-- events
	settings.disabled = true
	self:UpdateLayout()
end

function Boomkinator:MediaUpdate()

end
-------------------------------------------------------------------
-- Service Functions
-------------------------------------------------------------------
function Boomkinator:FormatTime(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	local mins = floor(time / 60)
	local secs = time - (mins * 60)
	return sformat("%d:%02d", mins, secs)
end

function Boomkinator:FormatShort(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	return sformat("%0.1f", time)
end
-------------------------------------------------------------------
-- Command Prompt Response
-------------------------------------------------------------------
function Boomkinator:Reset()
	local h = _G["BoomkinatorFrame"]
	h:ClearAllPoints()
	h:SetPoint("CENTER", "UIParent", "CENTER", 0, 0)
	--self:UpdateLayout()
end

-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

-------------------------------------------------------------------
-- External Event Handling
------------------------------------------------------------------
function Boomkinator:PLAYER_REGEN_ENABLED()
	--self:Print("Regen Enabled")
	self:CancelTimer(self.UpdateTimer, true)
	self:HideLayout()
end

function Boomkinator:PLAYER_REGEN_DISABLED()
	--self:Print("Regen Disabled")

	if updater == "" then
		--self:Print("Entered combat without settings, trying to fix UI")
		self:UpdateLayout()
	end
	
	if updater ~= "" then
		--self:Print(updater)
		self.UpdateTimer = self:ScheduleRepeatingTimer(updater, 0.1)
		self:ShowLayout()
	end
end

function Boomkinator:ACTIVE_TALENT_GROUP_CHANGED()
	--self:Print("Talents Changed")
	self:UpdateLayout()
end

function Boomkinator:CheckTalents()
	local _, class = UnitClass("player")
	
	if class == "DRUID" and GetSpecialization() == 1 then -- moonkin
		updater = "ButtonsOwlUpdate"
    elseif (class == "DRUID") and GetSpecialization() == 2 then -- cat
		updater = "ButtonsCatUpdate"
    elseif class == "HUNTER" and GetSpecialization() == 3 then -- hunter survival
		updater = "ButtonsHunterUpdate"
	elseif class == "MONK" and GetSpecialization() == 1 then -- monk brewmaster
		updater = "ButtonsBrewmasterUpdate"
	elseif class == "MONK" and GetSpecialization() == 3 then -- monk windwalker
		updater = "ButtonsWindwalkerUpdate"
	elseif class == "ROGUE" and  GetSpecialization() == 1 then -- rogue assassin
		updater = ""
	elseif class == "ROGUE" and  GetSpecialization() == 2 then -- rogue combat
		updater = "ButtonsCombatUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 2 then -- demonology
		updater = "ButtonsDemonologyUpdate"
	else
		updater = ""
		--self:Print("")	
	end
	--self:Print("CheckTalents = ".. updater)
end
-------------------------------------------------------------------
-- Buff UI
-------------------------------------------------------------------
function Boomkinator:UpdateLayout()
	--self:Print("Update Layout")
	local icons
	self:CheckTalents()
	if updater == "ButtonsOwlUpdate" then
		icons = Boomkinator.Icons["Owl"]
		-- extra icons for eclipses
		mfName, _, mfIcon = GetSpellInfo(8921) -- Moonfire
		sfName, _, sfIcon = GetSpellInfo(93402) -- Sunfire
	elseif updater == "ButtonsCatUpdate" then
		icons = Boomkinator.Icons["Cat"]
	elseif updater == "ButtonsHunterUpdate" then
		icons = Boomkinator.Icons["Hunter"]
	elseif updater == "ButtonsBrewmasterUpdate" then
		icons = Boomkinator.Icons["Brewmaster"]
	elseif updater == "ButtonsWindwalkerUpdate" then
		icons = Boomkinator.Icons["Windwalker"]
	elseif updater == "ButtonsCombatUpdate" then
		icons = Boomkinator.Icons["Combat"]
	elseif updater == "ButtonsDemonologyUpdate" then
		icons = Boomkinator.Icons["Demonology"]
	else
		icons = Boomkinator.Icons["None"]
	end

	if updater ~= nil then
		bframe = _G["BoomkinatorFrame"]

		ccount = _G["BoomkinatorFrameCCount"]
		ccount:SetText("")

		for i = 1, 9 do
			buttons[i] = _G["BoomkinatorFrameButton"..i]
			buttons[i]:SetTexture(icons[i])
			buttons[i]:SetVertexColor(1, 1, 1, 1)
			timers[i]  = _G["BoomkinatorFrameTime"..i]
			timers[i]:SetText("")
			timers[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
			stacks[i]  = _G["BoomkinatorFrameStack"..i]
			stacks[i]:SetText("")
			stacks[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
		end
	end

	BoomkinatorFrame:SetScale(settings.buffscale)
	self:HideLayout()

	if settings.locked then
		Boomkinator:LockLayout()
	else
		Boomkinator:UnlockLayout()
	end
end

function Boomkinator:ShowLayout()
	bframe:Show()
end

function Boomkinator:HideLayout()
	bframe:Hide()
end

function Boomkinator:LockLayout()
	bframe:EnableMouse(false)
end

function Boomkinator:UnlockLayout()
	bframe:EnableMouse(true)
end

function Boomkinator:GetSeverityColor(percent)
	if (percent >= 0.5) then
		return (1.0-percent)*2, 1.0, 0.0
	else
		return 1.0, percent*2, 0.0
	end
end

function Boomkinator:ButtonsDemonologyUpdate()
    local expire
	local spellName, spellIcon
	local combos, meta
		
	combos = 100 * UnitPower("player" , 15) / UnitPowerMax("player", 15) -- SPELL_POWER_DEMONIC_FURY
	
	if combos == 0 then
		stacks[1]:SetText("")
	else
		stacks[1]:SetText(string.format("%.0f", combos) .. "%")
	end
	buttons[1]:SetVertexColor(1, 1, 1, 0.7)	
	
	-- molten core, highlight soul fire
	spellName = Boomkinator.DemoSpells[1]
	buffName, _, _, buffCount, _, buffDuration, buffExpire  = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		stacks[2]:SetText("x" .. buffCount)
		timers[2]:SetText(Boomkinator:FormatShort(expire))
		buttons[2]:SetVertexColor(1, 1, 1, 0.5)
	else
		stacks[2]:SetText("")
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 0.5)
	end
	
	-- metamorphosis	
	spellName = Boomkinator.DemoSpells[2]
	buffName, _, _, _, _, _, _ = UnitBuff("player", spellName)
	
	if buffName then -- meta spells
		meta = 1
	else
		meta = 0
	end
	
	if UnitExists("target") then
		--check corruption
		spellName = Boomkinator.DemoSpells[3]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		end			

		--check doom
		spellName = Boomkinator.DemoSpells[4]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
	
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[5]:SetText("")
			if meta == 1 then
				buttons[5]:SetVertexColor(1, 1, 1, 1)
			else
				buttons[5]:SetVertexColor(1, 1, 1, 0.5)
			end
		end			
	end
	
	-- imp swarm
	spellName = Boomkinator.DemoSpells[5]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatTime(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.5)
	end
	
	-- grim: felguard
	spellName = Boomkinator.DemoSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.5)
	end
	
	-- dark soul
	spellName = Boomkinator.DemoSpells[7]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[8]:SetText("")
		buttons[8]:SetVertexColor(1, 1, 1, 1)
	else
		-- on cooldown
		expire = start + duration - GetTime()
		timers[8]:SetText(Boomkinator:FormatTime(expire))
		buttons[8]:SetVertexColor(1, 1, 1, 0.5)
	end

	-- doomguard
	spellName = Boomkinator.DemoSpells[8]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[9]:SetText("")
		buttons[9]:SetVertexColor(1, 1, 1, 1)
	else
		-- on cooldown
		expire = start + duration - GetTime()
		timers[9]:SetText(Boomkinator:FormatTime(expire))
		buttons[9]:SetVertexColor(1, 1, 1, 0.5)
	end
	
end

-------------------------------------------------------------------
-- Class Functionality: Rogue Combat
-------------------------------------------------------------------
function Boomkinator:ButtonsCombatUpdate()
    local expire
	local spellName, spellIcon
	local combos
	
	if UnitExists("target") then
		combos = GetComboPoints("player", "targer")
		if combos > 0 then
			stacks[1]:SetText("x" .. combos)
		else
			stacks[1]:SetText("")
		end
	
		-- check debuffs
		-- rupture
		spellName = Boomkinator.CombatSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[6]:SetText(Boomkinator:FormatShort(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 1)
		end		

		-- revealing strike
		spellName = Boomkinator.CombatSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end

		-- expose armor
		spellName = Boomkinator.CombatSpells[3]
		_, _, _, buffCount, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			stacks[4]:SetText("x" .. buffCount)
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.5)
		else
			stacks[4]:SetText("")
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		end		
	end
	
	-- self buffs
	
	-- slice and dice
	spellName = Boomkinator.CombatSpells[4]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[5]:SetText(Boomkinator:FormatShort(expire))
		buttons[5]:SetVertexColor(1, 1, 1, 0.5)
	else
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 1)
	end
	
	-- insights
	spellName = Boomkinator.CombatSpells[10]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		-- shallow
		expire = buffExpire - GetTime()
		stacks[3]:SetText("10%")
		timers[3]:SetText(Boomkinator:FormatShort(expire))
		buttons[3]:SetTexture("Interface\\Icons\\INV_Bijou_Green")
		buttons[3]:SetVertexColor(1, 1, 1, 0.5)
	else
		spellName = Boomkinator.CombatSpells[11]
		buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
		
		if buffName and buffExpire then
			-- moderate
			expire = buffExpire - GetTime()
			stacks[3]:SetText("20%")
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetTexture("Interface\\Icons\\INV_Bijou_Yellow")
			buttons[3]:SetVertexColor(1, 1, 1, 0.5)
		else
			spellName = Boomkinator.CombatSpells[12]
			buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
		
			if buffName and buffExpire then
				-- deep
				expire = buffExpire - GetTime()
				stacks[3]:SetText("30%")
				timers[3]:SetText(Boomkinator:FormatShort(expire))
				buttons[3]:SetTexture("Interface\\Icons\\INV_Bijou_Red")
				buttons[3]:SetVertexColor(1, 1, 1, 0.5)
			else
				-- no insights
				stacks[3]:SetText("")
				timers[3]:SetText("")
				buttons[3]:SetTexture("Interface\\Icons\\INV_Bijou_Silver")
				buttons[3]:SetVertexColor(1, 1, 1, 0.5)
			end
		end
	end
	
	-- check cooldowns
	local start, duration

	-- kick
	--spellName = Boomkinator.CombatSpells[4]
	--start, duration = GetSpellCooldown(spellName)
	--if start == 0 or (start > 0 and duration < 1.5 ) then
	--	timers[2]:SetText("")
	--	buttons[2]:SetVertexColor(1, 1, 1, 1)
	--else
	--	-- on cooldown
	--	expire = start + duration - GetTime()
	--	timers[2]:SetText(Boomkinator:FormatShort(expire))
	--	buttons[2]:SetVertexColor(1, 1, 1, 0.5)
	--end
	
	-- shiv
	--spellName = Boomkinator.CombatSpells[5]
	--start, duration = GetSpellCooldown(spellName)
	--if start == 0 or (start > 0 and duration < 1.5 ) then
	--	timers[3]:SetText("")
	--	buttons[3]:SetVertexColor(1, 1, 1, 1)
	--else
	--	-- on cooldown
	--	expire = start + duration - GetTime()
	--	timers[3]:SetText(Boomkinator:FormatShort(expire))
	--	buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	--end
	
	-- ks
	spellName = Boomkinator.CombatSpells[6]
	start, duration = GetSpellCooldown(spellName)

	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[7]:SetText("")
		buttons[7]:SetVertexColor(1, 1, 1, 1)
	else
		-- on cooldown
		expire = start + duration - GetTime()
		timers[7]:SetText(Boomkinator:FormatTime(expire))
		buttons[7]:SetVertexColor(1, 1, 1, 0.5)
	end
	
	-- rush
	spellName = Boomkinator.CombatSpells[7]
	start, duration = GetSpellCooldown(spellName)

	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[8]:SetText("")
		buttons[8]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[8]:SetText(Boomkinator:FormatTime(expire))
		buttons[8]:SetVertexColor(1, 1, 1, 0.5)
	end

	-- blades
	spellName = Boomkinator.CombatSpells[8]
	start, duration = GetSpellCooldown(spellName)

	if start then -- high enough to have it
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[9]:SetText("")
			buttons[9]:SetVertexColor(1, 1, 1, 1)
		else
		-- on cooldown
			expire = start + duration - GetTime()
			timers[9]:SetText(Boomkinator:FormatTime(expire))
			buttons[9]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[9]:SetText("NA")
		buttons[9]:SetVertexColor(1, 1, 1, 0.5)
	end
	
end

-------------------------------------------------------------------
-- Class Functionality: Monk Windwalker
-------------------------------------------------------------------
function Boomkinator:ButtonsWindwalkerUpdate()
    local expire
	local spellName, spellIcon --, buffName, buffCount, buffDuration, buffExpire
	local chi, comboT, comboK
	
	-- self buffs
	chi = UnitPower("player" , 12) -- SPELL_POWER_LIGHT_FORCE
	if chi == 0 then
		stacks[1]:SetText("")
	else
		stacks[1]:SetText("x" .. chi)
	end
	buttons[1]:SetVertexColor(1, 1, 1, 0.7)	

	-- tiger power
	spellName = Boomkinator.WindwalkerSpells[1]
	buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		stacks[2]:SetText("x" .. buffCount)
		timers[2]:SetText(Boomkinator:FormatShort(expire))
	else
		stacks[2]:SetText("x0")
		timers[2]:SetText("")
	end
	
	-- combo breaker: tiger palm
	spellName = Boomkinator.WindwalkerSpells[2]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if (buffName and buffExpire) or chi > 0 then
		-- highlight palm
		buttons[2]:SetVertexColor(1, 1, 1, 0.7)
	else
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- combo breaker: blackout kick
	spellName = Boomkinator.WindwalkerSpells[3]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if (buffName and buffExpire) or chi > 1 then
		-- highlight kick
		buttons[3]:SetVertexColor(1, 1, 1, 0.7)
	else
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- tigereye brew
	spellName = Boomkinator.WindwalkerSpells[4]
	buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		stacks[4]:SetText("x" .. buffCount)
		timers[4]:SetText(Boomkinator:FormatTime(expire))
	else
		stacks[4]:SetText("x0")
		timers[4]:SetText("")
	end
		
	-- cooldowns
	local start, duration
	--fists of fury
	spellName = Boomkinator.WindwalkerSpells[5]
	start, duration = GetSpellCooldown(spellName)

	if (start == 0 or (start > 0 and duration < 1.5 )) and chi > 2 then
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 0.7)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[5]:SetText(Boomkinator:FormatShort(expire))
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end

	--rising sun kick
	spellName = Boomkinator.WindwalkerSpells[6]
	start, duration = GetSpellCooldown(spellName)

	if (start == 0 or (start > 0 and duration < 1.5 )) and chi > 1 then
		timers[6]:SetText("")
		buttons[6]:SetVertexColor(1, 1, 1, 0.7)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[6]:SetText(Boomkinator:FormatShort(expire))
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
	
end

-------------------------------------------------------------------
-- Class Functionality: Monk Brewmaster
-------------------------------------------------------------------
function Boomkinator:ButtonsBrewmasterUpdate()

end
-------------------------------------------------------------------
-- Class Functionality: Druid Cat
-------------------------------------------------------------------
function Boomkinator:ButtonsCatUpdate()
	local expire
	local spellName, spellIcon
	local combos
	
	-- self buffs: savage roar
	spellName = Boomkinator.CatSpells[5]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[4]:SetText(Boomkinator:FormatShort(expire))
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	else
		timers[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	end
	
	-- target debuffs
	if UnitExists("target") then
		-- check combo points
		combos = GetComboPoints("player", "target")
	
		if combos > 0 then
			stacks[1]:SetText("x" .. combos)
		else
			stacks[1]:SetText("")
		end
	
		-- rip
		spellName = Boomkinator.CatSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end
	
		-- mangle
		spellName = Boomkinator.CatSpells[3]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil)
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		else
		--	-- check for trauma
		--	spellName = Boomkinator.CatSpells[8]
		--	_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil)
		--	if buffExpire then
		--		expire = buffExpire - GetTime()
		--		timers[3]:SetText(Boomkinator:FormatShort(expire))
		--		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		--	else
				timers[3]:SetText("")
				buttons[3]:SetVertexColor(1, 1, 1, 1)
		--	end
		end

		-- rake
		spellName = Boomkinator.CatSpells[4]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- check cooldowns
	local start, duration, berserk

	spellName = Boomkinator.CatSpells[6]
	-- check active berserk
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		berserk = 1
	else 
		berserk = 0
	end
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[7]:SetText("")
		buttons[7]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[7]:SetText(Boomkinator:FormatTime(expire))
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- tiger's fury	
	spellName =  Boomkinator.CatSpells[7]
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[6]:SetText("")
		if berserk == 0 then
			buttons[6]:SetVertexColor(1, 1, 1, 1)
		else -- blocked
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[6]:SetText(Boomkinator:FormatShort(expire))
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
end

-------------------------------------------------------------------
-- Class Functionality: Druid Moonkin
-------------------------------------------------------------------
function Boomkinator:ButtonsOwlUpdate()
	local expire
	local spellName, spellIcon
	
	local mooncycle = 0
	local suncycle  = 0
	local stars = 0
	-- show Moonfire or Sunfire

	local mfDuration, mfExpire, sfDuration, sfExpire

	spellName = Boomkinator.OwlSpells[11] -- lunar
	local buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		mooncycle = 1
		bLastCycle = 1
	end

	spellName = Boomkinator.OwlSpells[12] -- solar
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		suncycle = 1
		bLastCycle = 2
	end
	
	spellName = Boomkinator.OwlSpells[13] -- shooting stars
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		stars = 1
	end
	
	if UnitExists("target") then
		-- checking for debuffs on the target
		-- moonfire
		spellName = Boomkinator.OwlSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end
		
		-- sunfire
		spellName = Boomkinator.OwlSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end		
		
		--old logic
		-- moonfire and sunfire
		-- _, _, _, _, _, mfDuration, mfExpire = UnitDebuff("target", mfName, nil, "PLAYER")
		-- _, _, _, _, _, sfDuration, sfExpire = UnitDebuff("target", sfName, nil, "PLAYER")

		-- if mooncycle == 0 and suncycle == 0 then
			-- -- in the middle of cycles
			-- if sfExpire then -- sunfire still active
				-- expire = sfExpire - GetTime()
				-- timers[2]:SetText(Boomkinator:FormatShort(expire))
				-- buttons[2]:SetVertexColor(1, 1, 1, 0.3)
				-- buttons[2]:SetTexture(sfIcon)
			-- else
				-- if mfExpire then -- moonfire still active
					-- expire = mfExpire - GetTime()
					-- timers[2]:SetText(Boomkinator:FormatShort(expire))
					-- buttons[2]:SetVertexColor(1, 1, 1, 0.3)
				-- else -- moonfire inactive
					-- timers[2]:SetText("")
					-- buttons[2]:SetVertexColor(1, 1, 1, 1)
				-- end
				-- buttons[2]:SetTexture(mfIcon)
			-- end
		-- else
			-- -- moonfire or sunfire active
			-- if suncycle == 0 then
				-- -- moonfire
				-- spellName, _, spellIcon = GetSpellInfo(8921) -- Moonfire
			-- else
				-- -- sunfire
				-- spellName, _, spellIcon = GetSpellInfo(93402) -- Sunfire
			-- end
			-- _, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
			
			-- if buffExpire then
				-- expire = buffExpire - GetTime()
				-- timers[2]:SetText(Boomkinator:FormatShort(expire))
				-- buttons[2]:SetTexture(spellIcon)
				-- buttons[2]:SetVertexColor(1, 1, 1, 0.3)
			-- else
				-- timers[2]:SetText("")
				-- buttons[2]:SetTexture(spellIcon)
				-- buttons[2]:SetVertexColor(1, 1, 1, 1)
			-- end
		-- end
	end
	
	-- wrath or stafire
	if mooncycle == 1 then
		buttons[6]:SetVertexColor(1, 1, 1, 1)
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	elseif suncycle == 1 then
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	else
		if bLastCycle == 1 then -- from moon to sun
			buttons[6]:SetVertexColor(1, 1, 1, 1)
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		elseif bLastCycle == 2 then -- from Sun to Moon
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		else -- unknown transition
			buttons[6]:SetVertexColor(1, 1, 1, 0.75)
			buttons[4]:SetVertexColor(1, 1, 1, 0.75)
		end
	end
	timers[6]:SetText("")
	timers[4]:SetText("")
	
	-- check cooldowns
	local start, duration
	
	-- starfall
	spellName = Boomkinator.OwlSpells[7]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[3]:SetText("")
		buttons[3]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[3]:SetText(Boomkinator:FormatTime(expire))
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- starsurge
	spellName = Boomkinator.OwlSpells[5]
	start, duration = GetSpellCooldown(spellName)

	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 1)
	else
		-- on cooldown
		expire = start + duration - GetTime()
		timers[5]:SetText(Boomkinator:FormatShort(expire))
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- treants
	spellName = Boomkinator.OwlSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then -- has treants
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	
	end
	
	-- alignment
	spellName = Boomkinator.OwlSpells[8]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[8]:SetText("")
		buttons[8]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[8]:SetText(Boomkinator:FormatTime(expire))
		buttons[8]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- detonate
	spellName = Boomkinator.OwlSpells[9]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[9]:SetText("")
		buttons[9]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[9]:SetText(Boomkinator:FormatTime(expire))
		buttons[9]:SetVertexColor(1, 1, 1, 0.3)
	end
		
end

-------------------------------------------------------------------
-- Class Functionality: Hunter
-------------------------------------------------------------------
function Boomkinator:ButtonsHunterUpdate()
	local expire
	local spellName, spellIcon
		
	-- target debuffs
	if UnitExists("target") then
		-- Serpent Sting
		spellName = Boomkinator.HunterSpells[3]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- check cooldowns
	local start, duration

	-- Explovive Shot	
	spellName =  Boomkinator.HunterSpells[1]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		-- ready
		timers[1]:SetText("")
		buttons[1]:SetVertexColor(1, 1, 1, 1)
	else
		-- on cooldown
		expire = start + duration - GetTime()
		timers[1]:SetText(Boomkinator:FormatShort(expire))
		buttons[1]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- Black Arrow	
	spellName =  Boomkinator.HunterSpells[2]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		-- ready
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 1)
	else
		-- on cooldown
		expire = start + duration - GetTime()
		timers[2]:SetText(Boomkinator:FormatShort(expire))
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	--Kill Shot
	spellname = Boomkinator.HunterSpells[4]
	if UnitHealth("target")/UnitHealthMax("target") > 0.2 then 
		-- too soon
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	else
		start, duration = GetSpellCooldown(spellName)
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatTime(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		end
	end
end